/*
	Radiotastic
	http://www.radiotastic.com
	Copyright 2006 (c) Bitcartel Software.  All rights reserved.
*/

// Version
var gCFBundleVersion = 0.93;
var gVersionUpdateUrl='http://www.bitcartel.com/radiotastic-version.txt';

// My Constants
var kSlideEditorOffset = -25;

// Stations
var gStationsArray;
var gDefaultStationsArray = [
"ABC Radio Australia News","http://www.abc.net.au/streaming/newsradio.ram",
"BBC Radio 1","http://www.bbc.co.uk/radio1/realaudio/media/r1live.ram",
"BBC Radio 2","http://www.bbc.co.uk/radio2/realmedia/fmg2.ram",
"BBC Radio 3","http://www.bbc.co.uk/radio3/ram/r3g2.ram",
"BBC Radio 4","http://www.bbc.co.uk/radio4/realplayer/media/fmg2.ram",
"BBC Radio Five Live","http://www.bbc.co.uk/fivelive/live/surestream.ram",
"BBC World Service","http://www.bbc.co.uk/worldservice/ram/live_infent.ram",
"BBC 1Xtra","http://www.bbc.co.uk/1xtra/realmedia/1xtralive.ram",
"BBC 6 Music","http://www.bbc.co.uk/6music/ram/dsatg2.ram",
"BBC 7","http://www.bbc.co.uk/bbc7/realplayer/dsatg2.ram",
"BBC Asian Network","http://www.bbc.co.uk/asiannetwork/rams/asiannetwork.ram",
"BBC Sports Extra","http://www.bbc.co.uk/fivelive/live/surestream_sportsextra.ram",
"CBC R1","http://www.cbc.ca/mrl2/livemedia/cbcr1-toronto.asx",
"KCRW","http://kcrw.com/smil/simulcast.ram",
"KQED","http://www.kqed.org/streamingfiles/kqed_real.ram",
"KUSC","http://www.kusc.org/streams/kusc96.m3u",
"NPR News","http://www.npr.org/realmedia/news2a.ram",
"VOA News","http://www.voanews.com/real/voa/english/nnow/newsnowa.ram",
"WBEZ","http://www.chicagopublicradio.org/livestream/mp3.m3u",
"WBGO","http://wbgo.streamguys.net/listen.pls",
"WBUR","http://live.wbur.org/feed/wburlive.asx",
"WFUV","http://www.wfuv.org/wfuvmp3.pls",
"WNYC","http://www.wnyc.org/stream/fm.pls"
];

//
// XMLHTTPREQUEST ready state constants.
//
var XMLHTTPREQUEST_READY_STATE_UNINITIALIZED = 0;
var XMLHTTPREQUEST_READY_STATE_LOADING       = 1;
var XMLHTTPREQUEST_READY_STATE_LOADED        = 2;
var XMLHTTPREQUEST_READY_STATE_INTERACTIVE   = 3;
var XMLHTTPREQUEST_READY_STATE_COMPLETED     = 4;

// Enums
var mediaPlayerTypes = {
	none : 0,
	real : 1,
	qt : 2,
	wmp : 3
}

// Buttons
var gDoneButton;
var gInfoButton;
var gVolumeSlider;

// Functors
var gPlayerStartFunction = null;
var gPlayerStopFunction = null;

// Misc
var gSavedStationsFromNotification = null;
var gMediaPlayer = 0;
var gStartTimeWMP = 0;
var gPlayClickedStationName = null;
var gUpdateLCDTimer = null;
var gBlinkingRedDotTimer = null;
var gWidgetHidden = false;
var gSlideAnimator = null;



// setup() is the onload handler for the widget.
function setup()
{
	playerCleanup();
	
	gMediaPlayer = mediaPlayerTypes.none;

	/*
	Setup buttons and slider
	*/
	gDoneButton = new AppleGlassButton(document.getElementById("doneButton"), "Done", hidePrefs);
	gInfoButton = new AppleInfoButton(document.getElementById("infoButton"), document.getElementById("front"), "white", "white", showPrefs);
	gVolumeSlider = new AppleHorizontalSlider(document.getElementById("volumeSlider"), handler_volumeSliderChanged);
	gVolumeSlider.setValue(1);
	gVolumeSlider.refresh();

	/*
	Setup the radio stations popup
	*/
	loadStations();
	
	
	/*
	Update labels on back side
	*/
	var encodingFormatLabel = document.getElementById("encodingFormatLabel");
	encodingFormatLabel.innerText = "Encoding Format:";
	
	var encodingFormatLabel = document.getElementById("pluginsDetectedLabel");
	encodingFormatLabel.innerText = "Internet Plug-Ins:";
	
	var proLabel = document.getElementById("proLabel");
	proLabel.innerText = "Pro Registration:";
	
	setStatusConnectionText('Ready');
}



function handler_slidePanelToPosition(animation, current, start, finish)
{
	var elem = document.getElementById("editor");
	elem.style.top = parseInt(current);
}

function handler_slideOutCompleted()
{
	var elem = document.getElementById("editor");
	elem.style.display = "none";
	window.resizeTo(document.frontImage.width, document.frontImage.height);
	gSlideAnimator = null;
}

function handler_slideInCompleted()
{
	gSlideAnimator = null;
}

function toggleEditor()
{
	// Do nothing if slide animation in progress
	if (gSlideAnimator != null) {
		return;
	}

	var elem = document.getElementById("editor");
	var editorVisible = (elem.style.display == "block");
	var duration = 500;
	var interval = 15;
	
	var frontHeight = document.frontImage.height;	// note: if layer display is ever 'none', height is zero

	if (editorVisible) {
		// Slide the editor out of view, when finished restore size of window
		var start = frontHeight + kSlideEditorOffset;
		var finish = 0;
		gSlideAnimator = new AppleAnimator(duration, interval, start, finish, handler_slidePanelToPosition);
		gSlideAnimator.oncomplete = handler_slideOutCompleted;
	} else {
		// Slide the editor into view, resize window height so editor is visible
		elem.style.display = "block";
		window.resizeBy(0, frontHeight);
		var start = 0;
		var finish = frontHeight + kSlideEditorOffset;
		gSlideAnimator = new AppleAnimator(duration, interval, start, finish, handler_slidePanelToPosition);
		gSlideAnimator.oncomplete = handler_slideInCompleted;
	}
	gSlideAnimator.start();

}


// Blinking record button means waiting for audio / recording
function timer_blinkRedDot() {
	var v = document.getElementById("statusRecordingIcon").style.display;
	document.getElementById("statusRecordingIcon").style.display = (v=="none")?"block":"none";
}


/*

Public functions - invoked by Bridge

*/
function bridge_noAudioTimeOut()
{
	// Fudge: guard against manual stop triggering no audio time-out.
	if (gMediaPlayer != mediaPlayerTypes.none) {
		playerStop();
		handleError('No audio: Timed-out');
	}
}

function bridge_encodingFormat()
{
	var elem = document.getElementById("encodingFormatPopup");
	return elem.options[elem.selectedIndex].value;
}

function bridge_updateRecordingStatus()
{
	var isRecording = TheBridge.isRecording();
	var isPlaying = TheBridge.isPlaying();
	var isMute = TheBridge.isMute();

	document.getElementById("statusAudioIcon").style.display = (isPlaying) ? "block" : "none";

	// Blinking record indicator
	if (isRecording && gBlinkingRedDotTimer==null) {
		if (gWidgetHidden == false) {
			gBlinkingRedDotTimer = setInterval("timer_blinkRedDot()", 900);
		}
		document.getElementById("statusRecordingIcon").style.display = "block";
	} else if (!isRecording && gBlinkingRedDotTimer!=null) {
		clearInterval(gBlinkingRedDotTimer);
		gBlinkingRedDotTimer = null;
		document.getElementById("statusRecordingIcon").style.display = "none";
	} else if (!isRecording) {
		document.getElementById("statusRecordingIcon").style.display = "none";
	}

	// Record button has different image when recording
	if (!isRecording) {
		document.getElementById("recordButton").src = "Images/record_off_normal.png";
		document.getElementById("recordButton").onmouseup = 'this.src="Images/record_off_normal.png"';
		document.getElementById("recordButton").onmousedown = 'this.src="Images/record_off_pressed.png"';
	} else {
		document.getElementById("recordButton").src = "Images/record_on_Normal.png";
		document.getElementById("recordButton").onmouseup = 'this.src="Images/record_on_Normal.png"';
		document.getElementById("recordButton").onmousedown = 'this.src="Images/record_on_pressed.png"';
	}
	
	
	// Mute button
	if (!isMute) {
		document.getElementById("muteButton").src = "Images/mute_normal.png";
		document.getElementById("muteButton").onmousedown = 'this.src="Images/mute_pressed.png"';
		
	} else {
		document.getElementById("muteButton").src = "Images/mute_pressed.png";
	}
}



// Update Connection Status - QuickTime Player
function qt_updateConnectionStatus()
{
	if (document.player) {
		var title = document.player.GetPluginStatus();
		if ((title=="Playable") || (title=="Complete")) {
			title = "Playing";
		}
		setStatusConnectionText(title);
	}
}


// Update Connection Status - WMP
function wmp_updateConnectionStatus()
{
	if (document.player) {
		var title = (TheBridge.isPlaying()) ? "Playing" : "Loading";
		setStatusConnectionText(title);
	}
}


// Callback - invoked when volume slider is used.
// Value is 0.0 to 1.0, while QT and Real have volumes of 0 to 100.
function handler_volumeSliderChanged(currentValue)
{
	var x = parseInt(currentValue * 100);
	if (document.player) {
		if (gMediaPlayer == mediaPlayerTypes.wmp) {
			// Not implemented in WMP 9.  Does not work.
		} else {
			document.player.SetVolume(x);
		}
	}
}


// Stop playing if a media player has been set up
function playerStop()
{
	if (gMediaPlayer != mediaPlayerTypes.none) {
		if (gPlayerStopFunction!=null) gPlayerStopFunction.call(document.player);
		TheBridge.stopRecording();
		playerCleanup();
	} else {
		// If user just clicks stop, on error message, should reset display
		playerCleanup();
	}
}

// Toggle recording
function playerRecord()
{
	var isRecording = TheBridge.isRecording();
	if (isRecording || (gMediaPlayer != mediaPlayerTypes.none)) {
		if (!isRecording) handleError(''); // clear existing error record
		TheBridge.toggleRecording();
	}
}


function playerMute()
{
	if (window.widget) {
		TheBridge.toggleMute();
	}
}


function playerCleanup()
{
	TheBridge.terminateNoAudioTimer();
	
	gMediaPlayer = mediaPlayerTypes.none;
	clearInterval(gUpdateLCDTimer);
	gUpdateLCDTimer = null;
	var player = document.getElementById("radioplayer");
	player.innerHTML = "";

	setStatusConnectionText('Ready');
	setStatusElapsedTimeText(null);
	setStatusBitrateText(0);
	setStatusAudioFormatIcon(null);

//	document.getElementById("statusRecordingIcon").style.display = "none";

	updateLCD();
	setStationNameText('Radiotastic');
	handleError("");

	// re-display the volume slider, if hidden by WMP player
	document.getElementById("volumeSlider").style.display ='block';
}



/*

Buttons clicked - action methods

*/
function playClicked()
{
	if (gMediaPlayer == mediaPlayerTypes.none) {
		var select = document.getElementById("stationsPopup");
		var index = select.selectedIndex;
		if (index>0) {
			var url = select.options[index].value;
			var name = select.options[index].text;
			gPlayClickedStationName = name;

			// Clear the 'Ready' and error text.
			setStationNameText(name);
			setStatusConnectionText(null);
			handleError(""); // start a new playing session, so clear error.

			playURL(url);
		}
	}
}




function saveClicked()
{
	var name = document.getElementById("editStationName").value;
	var url = document.getElementById("editStationUrl").value;

	// Strip leading and ending whitespace from name
	var m = name.match(/^\s+(.*?)\s+$/);
	if (m) {
		name = m[1];
		document.getElementById("editStationName").value = name;
	}
	//alert("name='" + name + "'");

	var select = document.getElementById("stationsPopup");
	var index = select.selectedIndex;
	if (index==0) {
		// add a new station to end of list
		select.options[select.options.length] = new Option(name, url);
	} else {
		// a station is selected, so modify it.
		var option = select.options[index];
		option.text = name;
		option.value = url;
	}
	
	saveStations();
	sortStations();
	changeStation(select);
}

function deleteClicked()
{
	var select = document.getElementById("stationsPopup");
	var index = select.selectedIndex;
	if (index>0) {
		select.options[select.selectedIndex] = null;
	}
	//resetEditorForm();
	saveStations();	
	changeStation(select);
}

function revealClicked()
{
	TheBridge.revealDownloadPath();
}




function showPrefs()
{
	var front = document.getElementById("front");
	var back = document.getElementById("back");

	if (window.widget) {
		widget.prepareForTransition("ToBack");		// freezes the widget so that you can change it without the user noticing
	}

	front.style.display="none";		// hide the front
	back.style.display="block";		// show the back

	// Hide the editor when flipping
	var editor = document.getElementById("editor");
	editor.style.display = "none";
	editor.style.top = 0;

	if (window.widget) {
		setTimeout ('widget.performTransition();', 0);		// and flip the widget over	
	}
	
	// Perform software update and display current version
	TheBridge.prepareWidgetBack();
	softwareUpdate();
	checkInstalledPlugIns();
}


function hidePrefs() {
	var front = document.getElementById("front");
	var back = document.getElementById("back");

	if (window.widget) {
		widget.prepareForTransition("ToFront");		// freezes the widget and prepares it for the flip back to the front
	}

	back.style.display="none";			// hide the back
	front.style.display="block";		// show the front

	if (window.widget) {
		setTimeout ('widget.performTransition();', 0);		// and flip the widget back to the front
	}
}


// makeKey makes the widget multi-instance aware
function makeKey(key)
{
	if (window.widget) {
		return (widget.identifier + "-" + key);
	} else {
		return key;
	}
}




/*
Setters - for text labels
*/

function handleError(error)
{
	if (error != '') {
		alert('RadioTastic Error: '+error);
	}

	error = error.substring(0, 30);
	var elem = document.getElementById("statusInfoText");
	elem.innerText = error;
	elem.style.color = "#FF0000";
}

function setStationPopupText(title)
{
	var elem = document.getElementById("stationsPopupText");
	if (title && title.length>0) {
		elem.innerText = title.substring(0,16);
	} else {
		elem.innerText = "-";
	}
}

function setStatusConnectionText(title)
{
	var elem = document.getElementById("statusConnectionText");
	if (title && title.length>0) {
		elem.innerText = title.substring(0,40);
	} else {
		elem.innerText = "-";
	}
}

function setStationNameText(title)
{
	var elem = document.getElementById("stationNameText");
	if (title && title.length>0) {
		elem.innerText = title.substring(0,16) + ((title.length>16) ? "..." : "");
	} else {
		elem.innerText = "-";
	}
}

function setStatusElapsedTimeText(title)
{
	var elem = document.getElementById("statusElapsedTimeText");
	if (title && title.length>0) {
		elem.innerText = title.substring(0,8);
	} else {
		elem.innerText = "-";
	}
}

function setStatusBitrateText(bitrate)
{
	var elem = document.getElementById("statusBitrateText");
	var title;
	if (bitrate>0) {
		title = bitrate + " kbps";
	} else {
		title = "";
	}
	
	elem.innerText = title;
}

// input: qt, real, wm
function setStatusAudioFormatIcon(format) {
	var elem = document.getElementById('statusAudioFormatIcon');
	var path = "";
	if (format != null) {
		path = "Images/small_" + format + "_icon.png";
	}
	elem.innerHTML = '<img name="statusAudioFormatIcon" src="' + path + '"/>';
}



function updateLCD() {
	var elem;
	switch(gMediaPlayer) {
		case mediaPlayerTypes.qt:
		{
			qt_updateConnectionStatus();
			updateElapsedTime(document.player.GetTime());
			//setStationNameText(document.player.GetTrackName(1));
			break;
		}
		case mediaPlayerTypes.real:
		{
			real_updateBitrateStatus();
			updateElapsedTime(document.player.GetPosition());
			break;
		}
		case mediaPlayerTypes.wmp:
		{
			wmp_updateConnectionStatus();
			var now = new Date();
			var secs = (now.getTime()-gStartTimeWMP);
			updateElapsedTime(secs);
			break;
		}
		case mediaPlayerTypes.none:
		{
			updateElapsedTime(0);
			break;
		}
	}

	/* Update button gfx */
	bridge_updateRecordingStatus();
}


// position in milliseconds from 0
function updateElapsedTime(position)
{
	var title = null;
	if (position==null) position = 0;
	
	position += 55;
	
	var position = Math.floor(position / 1000);	//position from milliseconds -> seconds
	var secs = position % 60;
	var hours = Math.floor(position/3600);
	var mins = (position - (hours*3600) - secs)/60;

	hours = hours % 100; // display upto 99 hours

	title = ((hours < 10) ? "0" : "") + hours + ":" +
			((mins < 10) ? "0" : "") + mins + ":" +
	 		((secs < 10) ? "0" : "") + secs;

	setStatusElapsedTimeText(title);
}


function real_updateBitrateStatus()
{
	// Get bitrate - GetBandwidthAverage, GetBandwidthCurrent
	var bw = document.player.GetBandwidthAverage();
	bw = Math.floor(bw/1000);
	setStatusBitrateText(bw);
}




// REALPLAYER JAVASCRIPT CALLBACKS

function player_OnErrorMessage(severity, rma_code, user_code, user_string, more_info_url, error)
{
	handleError(error);
}

function player_OnTitleChange(title)
{
	if ((title != '') &&(title != null)) {
		setStationNameText(title);
	}
}

function player_OnBuffering( flags, percent_complete)
{
	var elem = document.getElementById("statusConnectionText");
	var title = "Buffering " + percent_complete + "%";
	setStatusConnectionText(title);		
}

function player_OnPlayStateChange( old_state,  new_state)
{
	var title = null;

	switch(new_state) {
		case 0:
		{
			// Stopped
			playerStop();
			title = "Stopped";
			break;
		}
		case 1:
		{
			// Contacting
			title = "Connecting";
			break;
		}
		case 2:
		{
			// Buffering
			title = "Buffering";
			break;
		}
		case 3:
		{
			// Playing
			title = "Playing";
			if (gUpdateLCDTimer == null)
			{
				updateLCD(); // reload and update immediately!
				if (gWidgetHidden == false) {
					gUpdateLCDTimer = setInterval("updateLCD()", 500);
				}
			}
			break;
		}
		case 4:
		{// Seeking
			title = "Seeking";
		}
		break;
	}

	setStatusConnectionText(title);		
}



function listenWithQT(newSource)
{	
	gMediaPlayer = mediaPlayerTypes.qt;
	TheBridge.prepareQTPlayer_(newSource);
	//navigator.plugins.refresh(true);

	gPlayerStartFunction = document.player.Play;
	gPlayerStopFunction = document.player.Stop;

	updateLCD();
	if (gWidgetHidden == false) {
		gUpdateLCDTimer = setInterval("updateLCD()", 500);
	}
	
	var x = parseInt(gVolumeSlider.value * 100);
	document.player.SetVolume(x);
}


function listenWithWMP(newSource)
{
	gMediaPlayer = mediaPlayerTypes.wmp;	
	TheBridge.prepareWMPPlayer_(newSource);
	//navigator.plugins.refresh(true);

	// disable the volume slider
	document.getElementById("volumeSlider").style.display ='none';

	gStartTimeWMP = new Date().getTime();
	updateLCD();
	if (gWidgetHidden == false) {
		gUpdateLCDTimer = setInterval("updateLCD()", 500);
	}
	handleError('Tip: Install Flip4Mac');
}

function listenWithReal(newSource)
{	
	gMediaPlayer = mediaPlayerTypes.real;
	TheBridge.prepareRealPlayer_(newSource);
	//navigator.plugins.refresh(true);
	document.player.SetWantErrors(true);	// Doesn't seem to work, dialog boxes still appear.
	gPlayerStartFunction = document.player.DoPlay;
	gPlayerStopFunction = document.player.DoStop;	
	var x = parseInt(gVolumeSlider.value * 100);
	document.player.SetVolume(x);
}


function checkInstalledPlugIns() {
	// Check installed plug-ins
	var b = (navigator.mimeTypes["audio/x-pn-realaudio-plugin"] != null);
	document.getElementById("realPluginIcon").style.display = (b) ? "block" : "none";
	b = (navigator.mimeTypes["application/x-mplayer2"] != null);
	document.getElementById("winPluginIcon").style.display = (b) ? "block" : "none";	
	b = (navigator.mimeTypes["video/quicktime"] != null);
	document.getElementById("qtPluginIcon").style.display = (b) ? "block" : "none";
}



var httpRequest = null;
var httpRequestUrl = null;

function playURL(url)
{	
	if (false == TheBridge.networkReachable()) {
		handleError("No Internet connection");
		return;
	}
	
	if (httpRequest != null) {
		httpRequest.abort();
	}

	httpRequestUrl = url;
	httpRequest = new window.XMLHttpRequest();
	if (httpRequest != null) {
		httpRequest.onreadystatechange=playURLStateChange;
		httpRequest.open("GET",url,true);
		httpRequest.send(null);
	} else {
		handleError("Create XMLHttpRequest failed!");
	}	
}

function playURLStateChange()
{
	if (httpRequest.readyState >= XMLHTTPREQUEST_READY_STATE_INTERACTIVE) {
		var contentType = TheBridge.playerNameForStation_url_(gPlayClickedStationName, httpRequestUrl);
		httpRequest.abort();	// abort now deletes request info
		var mimeType = navigator.mimeTypes[contentType];
		var plugin = null;
		var name = null;		
		if (mimeType != null) {
			plugin = navigator.mimeTypes[contentType].enabledPlugin;
			if (plugin != null) {
				var name = plugin.name;
			}
		}

		if (!name) {
			if (!TheBridge.networkReachable()) {
				handleError("No Internet connection");
			} else if (contentType){
				handleError('No suitable plug-in found');
			} else if (!contentType) {
				handleError('Check address of audio stream');
			}
			return;
		}
		
		var realRE = /^RealPlayer.*/i;
		var flipRE = /^Flip4Mac.*/i;
		var qtRE = /^QuickTime.*/i;
		var winRE = /^Windows.*/i;
		if (name.match(realRE)) {
			listenWithReal(httpRequestUrl);
			setStatusAudioFormatIcon("real");
		} else if (name.match(winRE)) {
			listenWithWMP(httpRequestUrl);
			setStatusAudioFormatIcon("wm");
		}
		else if (name.match(flipRE) || name.match(qtRE)) {
			listenWithQT(httpRequestUrl);
			if (name.match(flipRE)) {
				setStatusAudioFormatIcon("wm");
			} else {
				setStatusAudioFormatIcon("qt");
			}			
		}
	}
}




/***************/
// VERSION CHECK
/***************/

function softwareUpdate()
{
	xmlhttp=new XMLHttpRequest();
	xmlhttp.onreadystatechange=function() {
		if(xmlhttp.readyState==XMLHTTPREQUEST_READY_STATE_COMPLETED) {
			if (xmlhttp.responseText!='' && xmlhttp.status==200 && xmlhttp.responseText > gCFBundleVersion) {
				setSoftwareUpdateHTML('v' + gCFBundleVersion + 
'&nbsp;/&nbsp;<a href="#" target="_blank" onClick="if(window.widget){widget.openURL(\'http://www.bitcartel.com/radiotastic\');}">Download Update ' + xmlhttp.responseText + '</a>');
			} else {
				setSoftwareUpdateHTML('v' + gCFBundleVersion + '&nbsp;/&nbsp;<a href="#" target="_blank" onClick="if(window.widget){widget.openURL(\'http://www.bitcartel.com\');}">Bitcartel Software!</a>');
			}
		}
	}
	xmlhttp.open("GET",gVersionUpdateUrl,true);
	xmlhttp.send(null);
}

function setSoftwareUpdateHTML(title)
{
	var elem = document.getElementById("softwareUpdateText");
	if (title && title.length>0) {
		elem.innerHTML = title;
	} else {
		elem.innerHTML = "";
	}
}



/***************/
// STATIONS: Load, Save (not per widget instance, stations are shared), Sort
/***************/

function loadStations()
{
	var stations = null;
	if (window.widget) {
		stations = widget.preferenceForKey("stations");
		if (stations==null) {
			stations = gDefaultStationsArray.join("\n");
			widget.setPreferenceForKey(stations, "stations");
		}
	} else {
		stations = gDefaultStationsArray.join("\n");
	}
	gStationsArray = stations.split("\n");

	/*
	Setup the radio stations popup
	*/
	var count = gStationsArray.length;
	var i = 0;
	var select = document.getElementById("stationsPopup");
	select.options.length = 0;
	select.options[0] = new Option("Add Station...", "");
	var idx = 1;
	while (i < count) {
		select.options[idx++] = new Option(gStationsArray[i], gStationsArray[i+1]);
		i += 2;
	}

	sortStations();	// sort the list
	setStationPopupText( select.options[select.selectedIndex].text );

	/*
	Setup the station editor panel
	*/
	document.getElementById("editStationName").defaultValue = "Name";
	document.getElementById("editStationUrl").defaultValue = "URL";
}

function saveStations()
{
	// Clear the array
	gStationsArray.length = 0;
	var select = document.getElementById("stationsPopup");
	var n = select.length;
	// Ignore 'add station'
	for(i=1; i<n; i++)  {
		gStationsArray.push(select.options[i].text);	// name
		gStationsArray.push(select.options[i].value);	// url
	}

	// Store stations in prefs, and send notification to other widget instances
	var stations = gStationsArray.join("\n");	
	if (window.widget) {
		widget.setPreferenceForKey(stations, "stations");
	}
	TheBridge.sendSaveNotificationFromWidget_stations_((window.widget) ? widget.identifier : 'anon', stations);
}

// This method is invoked when notification received
function bridge_loadStations(identifier)
{
	if (widget.identifier != identifier) {
		alert("widget: " + widget.identifier + " setting new stations");
		if (window.widget) {
			widget.setPreferenceForKey(gSavedStationsFromNotification, "stations");
		}
		loadStations();

		var select = document.getElementById("stationsPopup");		
		changeStation(select);
	}
}


// Sort the stations SELECT list, avoiding the first entry "Add stations...", preserving currently selected option
// Bug: In comparisons, b > a, result is sometimes undefined, so use my own method for now.
function compareTextFunction (option1, option2) {
	var a = option1.text.toLowerCase();
	var b = option2.text.toLowerCase();
	var result = TheBridge.compareString_withString_(a,b);
	return result;
//	var result = (a < b) ? -1 : ((b > a) ? 1 : 0);
}

function sortStations()
{
	var select = document.getElementById('stationsPopup');
	if (select.length<=1) return;

	var arrObjs = new Array();
	for(i=1; i<select.length; i++)  {
		var option = new Option(select.options[i].text, select.options[i].value);
		option.selected = select.options[i].selected;
		arrObjs.push(option);
	}
	arrObjs.sort(compareTextFunction);
	
	//alert('select length  = ' + select.length);
	//alert('arrObjs length = ' + arrObjs.length)
	
	select.options.length = 1;
	for(i=0; i<arrObjs.length; i++)  {
		select.options[i+1] = arrObjs[i];
		//alert(arrObjs[i].text + ' --> ' + arrObjs[i].value);
	}
}


/*
Do not stop playing when new station selected.  If no station is playing, then update the station name display.
*/
function changeStation(elem)
{	
	var index = [elem.selectedIndex];
	var url = elem.options[elem.selectedIndex].value;
	var name = elem.options[elem.selectedIndex].text;
	setStationPopupText(name);
	
	// 'Add station...' selected, so reveal editor.
	if (index == 0) {
		var editorVisible = (document.getElementById("editor").style.display == "block");
		if (gSlideAnimator==null && !editorVisible) {
			toggleEditor();
		}
	}	

	if (index>0) {
		if (gMediaPlayer == mediaPlayerTypes.none) {
			setStationNameText(name);
		}		

		document.getElementById("editStationName").value = name;
		document.getElementById("editStationUrl").value = url;
	} else {
		resetEditorForm();
	}
}


function resetEditorForm()
{
	document.getElementById("editStationName").value = document.getElementById("editStationName").defaultValue;
	document.getElementById("editStationUrl").value = document.getElementById("editStationUrl").defaultValue;	
}




/***************/
// WIDGET EVENTS
/***************/

// removed is called when the widget is removed from the Dashboard
function removed()
{
	TheBridge.cleanup();
}

// focused is called when the widget gets key focus
function focused()
{
}

// blurred is called when the widget loses key focus
function blurred()
{
}

function onshow()
{
	gWidgetHidden = false;
	
	if (document.player != null) {
		if (gMediaPlayer != mediaPlayerTypes.none) {
			if (gUpdateLCDTimer == null) {
				gUpdateLCDTimer = setInterval("updateLCD()", 500);
			}
		}
		
		// Update status icons and red blinking dot timer
		bridge_updateRecordingStatus();
	}
}

function onhide()
{
	gWidgetHidden = true;

	if (gUpdateLCDTimer != null) {
		clearInterval(gUpdateLCDTimer);
		gUpdateLCDTimer = null;
	}
	
	if (gBlinkingRedDotTimer != null) {
		clearInterval(gBlinkingRedDotTimer);
		gBlinkingRedDotTimer = null;
	}
	
}

// Register for some widget events
if(window.widget)
{
	widget.onremove = removed;
	window.onfocus = focused;
	window.onblur = blurred;
	widget.onshow = onshow;
	widget.onhide = onhide;
}
